.include "m32def.inc"

jmp start

loadregisters: ;208 TZ +4+4
 CLR Zl		;1
 CLR Zh         ;1d
 CLR r29        ;1
 loadregisterloop: ;29 mal ausgefuehrt=203-1
   ST Z+,r29    ;2
   inc r29      ;1
   CPI r29,29   ;2  
   BRLO loadregisterloop ;2 bei hoch, sonst 1
 LDI r29,29 ;1
 LDI r30,30 ;1
 LDI r31,31 ;1
 ret   
 

start:
  LDI r16,31
  OUT DDRA,r16
  LDI r16, low(RAMEND)
  OUT SPL,r16
  LDI r16,high(RAMEND);
  OUT SPH,r16
  call chargen_init
  call seriell_init;
  LDI r16,0
  STS linecounter,r16
  call loadregisters
  jmp imagestart


nextline:
 ;Berechnet Pointer auf Zeilentabelle
  LDS Zl,imagepointer	;2
  LDS Zh,imagepointer+1	;2
nextline_vor_LPM: ;1015
  LPM r16,Z+		;3  1018
  ;TZ 10
  STS imagepointer,Zl	;2 1020
  STS imagepointer+1,zh	;2 1022
  CLR r17		;1  1023
  LDI Zl, low(linepointers*2);1 16
OUT PORTA,r0		;1 0
  LDI Zh,high(linepointers*2);1 1
  LSL r16 ;r16*8	;1 2
  ROL r17		;1 3
  LSL r16		;1 4
  ROL r17  		;1
  LSL r16		;1
  ROL r17		;1
  ADD Zl,r16		;1
  ADC Zh,r17		;1 9
  LDS r16,linecounter	;2
  inc r16		;1
  ANDI r16,$03		;1 13
  STS linecounter,r16	;2
  LSL r16		;1  16
  CLR r17
  ADD Zl,r16		;1
  ADC Zh,r17		;1
  LPM r16,Z+		;3
  LPM r17,Z+		;3 20
  MOVW zh:zl,r17:r16	;1
  LDI r16,16		;1
  LDI r17,17		;1  23
    ICALL ;Z ;Aufruf der Routine 3 TZ Ret 4 TZ =>1024-50-7=967 TZ (37-)
  ;TZ 1004
  LDS Zl,imagepointer	;2 1006
  LDS Zh,imagepointer+1	;2 1008
  LPM r16,Z 		;3 1011
  CPI r16,$ff		;1 1012
  BRNE nextline ;2 bei Sprung; 1 bei nicht
imagestart: ;Routine wird hier aufgerufen
  nop
  LDI Zl, low(image*2)  ; 1
  LDI Zh,high(image*2)  ; 1
  rjmp nextline_vor_LPM ; 2
    


.dseg
imagepointer: .byte 2;
linecounter: .byte 1
.cseg

.include "linepointers.inc"

image:
.include "image.inc"

.include "seriell.inc"

.include "chargen.inc"

;.include "image.inc"
.include "samples.inc"

.include "delays.inc"




